<?php
# This page sends an E-mail to the reporter if an issue is awaiting feedback
//require_once( '../../../core.php' ); #in script
require_once( '../../core.php' ); #in test
$t_core_path = config_get('core_path');
require_once( $t_core_path . 'email_api.php' );

$t_subject = "Tasks requiring your attention";

$t_rem_body1 = "Please review the following tasks";
$t_rem_body2 = "Please do not reply to this message";

# List of users with open tasks
$qh = "select distinct(task_handler) from mantis_plugin_Tasks_defined_table where task_completed ='0000-00-00 00:00:00' order by bug_id";
$rh = db_query_bound($qh);
$handler = array();
while ($h = db_fetch_array($rh)) {
    $handler[] = $h['task_handler'];
}
# List of groups with open tasks
$qg = "select distinct(task_group) from mantis_plugin_Tasks_defined_table where task_completed ='0000-00-00 00:00:00' order by bug_id";
$rg = db_query_bound($qg);
$group = array();
while ($g = db_fetch_array($rg)) {
    $group[] = $g['task_group'];
}
#cleanup array
array_unique($handler);
array_unique($group);

# get tasks for each handler
foreach ($handler as $th) {
    $tq = db_query_bound("select bug_id, task_id, task_title, task_due from mantis_plugin_Tasks_defined_table where task_handler = $th AND task_completed ='0000-00-00 00:00:00' order by bug_id ");
    $body = $t_rem_body1 . " \n\n";
    //$body .= "Complaint\tTask\tTask Title\tDue date" . "\n";
    $body .= "Due Date\tTitle" . "\n";
    $body .= "-----------------------------------------------------------------------" . "\n";

    while ($thr = db_fetch_array($tq)) {
        $complaint = $thr['bug_id'];
        $task = $thr['task_id'];
        $title = $thr['task_title'];
        $due = $thr['task_due'];
        $duedate = date ('Y-m-d', strtotime($due));
        $url = "http://scm.stahl.com/view.php?id=$complaint";

        //works only when generating html emails
        //$body .= "<a href=$url>".$complaint . "\t" . $task . "\t" . $title . "\t" . $due ."</a>". "\n\n";
        //$body .= $complaint . "\t" . $task . "\t" . $title . "\t" . $duedate . "\n\n";
        $body .= $duedate . " \t" . $title . "\n";
        $body .= "\t" . $url . "\n\n";
    }

    $body .= $t_rem_body2;

    $t_username = user_get_field($th, 'username');
    $t_email = user_get_email($th);
    //$t_email = user_get_email(2);
    $t_subject = "Tasks requiring your attention";
    if (!is_blank($t_email)) {
        email_store($t_email, $t_subject, $body);
        if (OFF == config_get('email_send_using_cronjob')) {
            email_send_all();
        }
    }

    //echo $t_username .' '. $t_email . '<br />';
    //echo $body;
    //echo "<br /><br /><br />";
}

# get tasks for each group
foreach ($group as $gh) {
    $tg = db_query_bound("select bug_id, task_id, task_title, task_due from mantis_plugin_Tasks_defined_table where task_group = $gh AND task_completed ='0000-00-00 00:00:00' order by bug_id ");
    $body = $t_rem_body1 . " \n\n";
    $body .= "Due Date\tTitle" . "\n";
    $body .= "-----------------------------------------------------------------------" . "\n";

    while ($tgr = db_fetch_array($tg)) {
        $complaint = $tgr['bug_id'];
        $task = $tgr['task_id'];
        $title = $tgr['task_title'];
        $due = $tgr['task_due'];
        $duedate = date ('Y-m-d', strtotime($due));
        $url = "http://scm.stahl.com/view.php?id=$complaint";

        $body .= $duedate . " \t" . $title . "\n";
        $body .= "\t" . $url . "\n\n";
    }
    $body .= $t_rem_body2;

    # get all users for group
    $grq = db_query_bound("select * from mantis_plugin_Usergroups_usergroup_table where group_id = $gh ");
    while ($grr = db_fetch_array($grq)) {

        $t_username = user_get_field($grr['id'], 'username');
        $t_email = user_get_email($grr['id']);
        //$t_email = user_get_email(2);
        $t_subject = "Group Tasks requiring your attention";
        if (!is_blank($t_email)) {
            email_store($t_email, $t_subject, $body);
            if (OFF == config_get('email_send_using_cronjob')) {
                email_send_all();
            }
        }

        //echo $t_username.' '.$t_email . '<br />';
        //echo $body;
        //echo "<br /><br /><br />";
    }
}
?>