<?php

# This creates an excel file with monthly management report
# last month and year to date
//require_once( '../../../core.php' ); //production
require_once( '../../core.php' ); //test
$t_core_path = config_get('core_path');

/** Include path * */
ini_set('include_path', ini_get('include_path') . ';G:/Sites/klacht/Classes/');
/** PHPExcel */
include 'PHPExcel.php';
/** PHPExcel_IOFactory */
require_once 'PHPExcel/IOFactory.php';
/** PHPExcel_Writer_Excel2007 */
include 'PHPExcel/Writer/Excel2007.php';
// Create new PHPExcel object

require_once 'PHPExcel/Cell/AdvancedValueBinder.php';
PHPExcel_Cell::setValueBinder(new PHPExcel_Cell_AdvancedValueBinder());

//Definitions
$filename = date(YmdHis) . '.xlsx';
$today = date('Y-m-d');
$thisyear = date('Y');
$thismonth = date('m');
$lastmonth = date('m') - 1;
$now = strtotime($today);
$startofthisyear = strtotime($thisyear . '-1-1');
$pastmonth = strtotime($thisyear . '-' . $lastmonth);

$objPHPExcel = new PHPExcel();
// Set properties
$objPHPExcel->getProperties()->setCreator("SCM");
$objPHPExcel->getProperties()->setLastModifiedBy("SCM");
$objPHPExcel->getProperties()->setTitle("SCM report");
$objPHPExcel->getProperties()->setSubject("SCM report");
$objPHPExcel->getProperties()->setDescription("Report generated by SCM");

//border definitions
$styleThinBlackBorderOut = array(
    'borders' => array(
        'outline' => array(
            'style' => PHPExcel_Style_Border::BORDER_THIN,
            'color' => array('argb' => 'FF000000'),
        )
    ),
);
$styleThinBlackBorderAll = array(
    'borders' => array(
        'outline' => array(
            'style' => PHPExcel_Style_Border::BORDER_THIN,
            'color' => array('argb' => 'FF000000'),
        ),
        'inside' => array(
            'style' => PHPExcel_Style_Border::BORDER_THIN,
            'color' => array('argb' => 'FF000000'),
        )
    ),
);
$styleThickBlackBorderOut = array(
    'borders' => array(
        'outline' => array(
            'style' => PHPExcel_Style_Border::BORDER_THICK,
            'color' => array('argb' => 'FF000000'),
        )
    ),
);

$styleThinBlackBorderHor = array(
    'borders' => array(
        'bottom' => array(
            'style' => PHPExcel_Style_Border::BORDER_THIN,
            'color' => array('argb' => 'FF000000'),
        ),
        'inside' => array(
            'style' => PHPExcel_Style_Border::BORDER_THIN,
            'color' => array('argb' => 'FF000000'),
        )
    ),
);

/* new sheet */
// start creating the sheet
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->mergeCells('B2:D2');
$objPHPExcel->getActiveSheet()->mergeCells('F2:H2');

//set column widths
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('12');
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('3');
$objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('H')->setWidth('10');
$objPHPExcel->getActiveSheet()->getColumnDimension('I')->setWidth('3');
$objPHPExcel->getActiveSheet()->getColumnDimension('J')->setWidth('10');

//set cell data
$objPHPExcel->getActiveSheet()->SetCellValue('A1', 'Complaints');
$objPHPExcel->getActiveSheet()->SetCellValue('B1', 'New');
$objPHPExcel->getActiveSheet()->SetCellValue('C1', 'Resolved');
$objPHPExcel->getActiveSheet()->SetCellValue('D1', 'Closed');
$objPHPExcel->getActiveSheet()->SetCellValue('E1', '');
$objPHPExcel->getActiveSheet()->SetCellValue('F1', 'New');
$objPHPExcel->getActiveSheet()->SetCellValue('G1', 'Resolved');
$objPHPExcel->getActiveSheet()->SetCellValue('H1', 'Closed');
$objPHPExcel->getActiveSheet()->SetCellValue('I1', '');
$objPHPExcel->getActiveSheet()->SetCellValue('J1', 'Currently');

$objPHPExcel->getActiveSheet()->SetCellValue('A2', 'Unit');
$objPHPExcel->getActiveSheet()->SetCellValue('B2', 'Previous month');
$objPHPExcel->getActiveSheet()->SetCellValue('E2', '');
$objPHPExcel->getActiveSheet()->SetCellValue('F2', 'Year to date');
$objPHPExcel->getActiveSheet()->SetCellValue('I2', '');
$objPHPExcel->getActiveSheet()->SetCellValue('J2', 'open');

$objPHPExcel->getActiveSheet()->getStyle('A1:J2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

$projects = db_query_bound("select id, name FROM mantis_project_table");
$i = 3; //start at line
while ($project = db_fetch_array($projects)) {
    #last month total created
    $qlmt = db_query_bound("select count(id) as new
             from mantis_bug_table
             where date_submitted BETWEEN $pastmonth AND $now
                AND project_id=" . $project['id'] . " ");
    $rlmt = db_fetch_array($qlmt);
    #last month total resolved
    $qlmr = db_query_bound("select count(id) as resolved
             from mantis_bug_table
             where date_submitted BETWEEN $pastmonth AND $now
                AND project_id=" . $project['id'] . "
                AND status = 80");
    $rlmr = db_fetch_array($qlmr);
    #last month total closed
    $qlmc = db_query_bound("select count(id) as closed
             from mantis_bug_table
             where date_submitted BETWEEN $pastmonth AND $now
                AND project_id=" . $project['id'] . "
                AND status = 90");
    $rlmc = db_fetch_array($qlmc);
    #this year total created
    $qyt = db_query_bound("select count(id) as new
             from mantis_bug_table
             where date_submitted BETWEEN $startofthisyear AND $now
                AND project_id=" . $project['id'] . " ");
    $ryt = db_fetch_array($qyt);
    #this year total resolved
    $qyr = db_query_bound("select count(id) as resolved
             from mantis_bug_table
             where date_submitted BETWEEN $startofthisyear AND $now
                AND project_id=" . $project['id'] . "
                AND status = 80");
    $ryr = db_fetch_array($qyr);
    #this year total closed
    $qyc = db_query_bound("select count(id) as closed
             from mantis_bug_table
             where date_submitted BETWEEN $startofthisyear AND $now
                AND project_id=" . $project['id'] . "
                AND status = 90");
    $ryc = db_fetch_array($qyc);

    #this year total closed
    $qc = db_query_bound("select count(id) as open
             from mantis_bug_table
             WHERE project_id=" . $project['id'] . "
                AND status < 80");
    $rc = db_fetch_array($qc);

    $objPHPExcel->getActiveSheet()->SetCellValue('A' . $i, $project['name']);
    $objPHPExcel->getActiveSheet()->SetCellValue('B' . $i, $rlmt['new']);
    $objPHPExcel->getActiveSheet()->SetCellValue('C' . $i, $rlmr['resolved']);
    $objPHPExcel->getActiveSheet()->SetCellValue('D' . $i, $rlmc['closed']);
    $objPHPExcel->getActiveSheet()->SetCellValue('E' . $i, '');
    $objPHPExcel->getActiveSheet()->SetCellValue('F' . $i, $ryt['new']);
    $objPHPExcel->getActiveSheet()->SetCellValue('G' . $i, $ryr['resolved']);
    $objPHPExcel->getActiveSheet()->SetCellValue('H' . $i, $ryc['closed']);
    $objPHPExcel->getActiveSheet()->SetCellValue('I' . $i, '');
    $objPHPExcel->getActiveSheet()->SetCellValue('J' . $i, $rc['open']);

    $i++;
}
$c = $i - 1;
$objPHPExcel->getActiveSheet()->SetCellValue('A' . $i, 'Totals');
$objPHPExcel->getActiveSheet()->SetCellValue('B' . $i, '=SUM(B3:B' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('C' . $i, '=SUM(C3:C' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('D' . $i, '=SUM(D3:D' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('E' . $i, '');
$objPHPExcel->getActiveSheet()->SetCellValue('F' . $i, '=SUM(F3:F' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('G' . $i, '=SUM(G3:G' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('H' . $i, '=SUM(H3:H' . $c . ')');
$objPHPExcel->getActiveSheet()->SetCellValue('I' . $i, '');
$objPHPExcel->getActiveSheet()->SetCellValue('J' . $i, '=SUM(J3:J' . $c . ')');

//set fonts
$objPHPExcel->getActiveSheet()->getStyle('A1:J2')->getFont()->setSize(10);
$objPHPExcel->getActiveSheet()->getStyle('A1:J2')->getFont()->setBold(true);
$objPHPExcel->getActiveSheet()->getStyle('A3:J' . $i)->getFont()->setSize(10);
$objPHPExcel->getActiveSheet()->getStyle('A' . $i . ':J' . $i)->getFont()->setBold(true);

//set borders
$objPHPExcel->getActiveSheet()->getStyle('A1:J2')->applyFromArray($styleThinBlackBorderAll);
$objPHPExcel->getActiveSheet()->getStyle('A' . $i . ':J' . $i)->applyFromArray($styleThinBlackBorderAll);

// Rename sheet
$objPHPExcel->getActiveSheet()->setTitle('All units');

//set pagebreaks
$objPHPExcel->getActiveSheet()->setBreak('A30', PHPExcel_Worksheet::BREAK_ROW);
$objPHPExcel->getActiveSheet()->setBreak('J30', PHPExcel_Worksheet::BREAK_COLUMN);

//set page orientation and papersize
$objPHPExcel->getActiveSheet()->getPageSetup()->setOrientation(PHPExcel_Worksheet_PageSetup::ORIENTATION_PORTRAIT);
$objPHPExcel->getActiveSheet()->getPageSetup()->setPaperSize(PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4);
$objPHPExcel->getActiveSheet()->getPageSetup()->setFitToWidth(1);
$objPHPExcel->getActiveSheet()->getPageSetup()->setFitToHeight(0);
// End sheet


$fullfile = config_get('plugin_Query_download_location', 'Query');
$fullfile .= $filename;

//save it
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save($fullfile);

//mail it

$from = config_get('plugin_Query_from_address', 'Query');
$recipients = explode(",", $target);
#now retrieve email addresses and fill the TO variable
$fields = count($recipients);
$to = '';
# now create the to address
for ($i = 0; $i < $fields; $i++) {
    if ($i > 0) {
        $to .= ",";
    }
    $username = $recipients[$i];
    $domain = strstr($username, '@');
    if (empty($domain)) {
        $userid = user_get_id_by_name($username);
        $t_email = user_get_email($userid);
    }
    else {
        $t_email = $username;
    }
    if ($t_email <> '') {
        $to .= $t_email;
    }
}
if ($to == '') {
    return false;
}
$today = date("F j, Y, g:i a");
$body = lang_get('plugin_query_body') . " \n\n";
$body .= $filename . " \n\n";
$body .= lang_get('plugin_query_date') . " \n\n";
$body .= $today;

// email fields: to, from, subject, and so on
$subject = "SCM-Report :" . $schedule_name;
$message = date("Y.m.d H:i:s") . "\n 1 attachment";
$headers = "From: $from";
$headers.="Return-Path:$from\r\n";

// boundary
$semi_rand = md5(time());
$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";

// headers for attachment
$headers .= "\nMIME-Version: 1.0\n" . "Content-Type: multipart/mixed;\n" . " boundary=\"{$mime_boundary}\"";

// multipart boundary
$message = "--{$mime_boundary}\n" . "Content-Type: text/plain; charset=\"iso-8859-1\"\n" .
        "Content-Transfer-Encoding: 7bit\n\n" . $message . "\n\n";

// preparing attachment
if (is_file($fullfile)) {
    $message .= "--{$mime_boundary}\n";
    $fp = @fopen($fullfile, "rb");
    $data = @fread($fp, filesize($fullfile));
    @fclose($fp);
    $data = chunk_split(base64_encode($data));
    $message .= "Content-Type: application/octet-stream; name=\"" . basename($filename) . "\"\n" .
            "Content-Description: " . basename($filename) . "\n" .
            "Content-Disposition: attachment;\n" . " filename=\"" . basename($filename) . "\"; size=" . filesize($fullfile) . ";\n" .
            "Content-Transfer-Encoding: base64\n\n" . $data . "\n\n";
}
else {
    return false;
}
$returnpath = "-f" . $from;
$ok = mail($to, $subject, $message, $headers, $returnpath);
//return $ok;

#and remove it
unlink($fullfile);
?>
